MMC5_REG_CTRL	=	$5000	; Rg[WX^
MMC5_REG_FREQ_L	=	$5002	; g(L)WX^
MMC5_REG_FREQ_H	=	$5003	; g(H)WX^
MMC5_START_CH	=	PTRMMC5	; Jnch
;----------------------------------------

sound_mmc5:
	lda	channel_sel
	asl	a
	tax
	dec	sound_counter,x
	bne	mmc5_return2000
	jsr	sound_mmc5_read
	lda	rest_flag,x
	and	#%00000001
	bne	mmc5_return1990

mmc5_duty_write:
	lda	effect_flag,x
	and	#%00000100
	beq	mmc5_softenve_write
	jsr	sound_mmc5_dutyenve

mmc5_softenve_write:
	lda	effect_flag,x
	and	#%00000001
	beq	mmc5_lfo_write
	jsr	sound_mmc5_softenve

mmc5_lfo_write:
	lda	effect_flag,x
	and	#%00010000
	beq	mmc5_pitch_enve_write
	jsr	sound_mmc5_lfo

mmc5_pitch_enve_write:
	lda	effect_flag,x
	and	#%00000010
	beq	mmc5_note_enve_write
	jsr	sound_mmc5_pitch_enve

mmc5_note_enve_write:
	lda	effect_flag,x
	and	#%00001000
	beq	mmc5_freq_write
	jsr	sound_mmc5_note_enve

mmc5_freq_write:
	jsr	sound_mmc5_write
mmc5_return1990
	rts

mmc5_return2000
	lda	rest_flag,x
	and	#%00000001
	bne	mmc5_return2010
mmc5_duty_write2:
	lda	effect_flag,x
	and	#%00000100
	beq	mmc5_softenve_write2
	jsr	sound_mmc5_dutyenve
mmc5_softenve_write2:
	lda	effect_flag,x
	and	#%00000001
	beq	mmc5_lfo_write_2
	jsr	sound_mmc5_softenve
mmc5_lfo_write_2:
	lda	effect_flag,x
	and	#%00010000
	beq	mmc5_pitch_enve_write_2
	jsr	sound_mmc5_lfo

mmc5_pitch_enve_write_2:
	lda	effect_flag,x
	and	#%00000010
	beq	mmc5_note_enve_write_2
	jsr	sound_mmc5_pitch_enve

mmc5_note_enve_write_2:
	lda	effect_flag,x
	and	#%00001000
	beq	mmc5_return2010
	jsr	sound_mmc5_note_enve
mmc5_return2010:
	rts
;------------------------------------------------
mmc5_freq_set:
	lda	channel_sel
	asl	a
	tax
	lda	sound_sel,x		;Kf[^ǂݏo
	and	#%00001111		;4bito
	asl	a
	tay

	lda	psg_frequency_table,y	;PSGge[uLowǂݏo
	sta	sound_freq_low,x	;
	iny				;yP₵
	lda	psg_frequency_table,y	;PSGge[uHighǂݏo
	sta	sound_freq_high,x	;

mmc5_oct_set1:

	lda	sound_sel,x		;Kf[^ǂݏo
	lsr	a			;4bito
	lsr	a			;
	lsr	a			;
	lsr	a			;

	sec				;IN^[u
	sbc	#$02

	beq	mmc5_freq_end		;[Ȃ炻̂܂܏I
	tay

mmc5_oct_set2:

	lsr	sound_freq_high,x	;EVtg@C
	ror	sound_freq_low,x	;C玝Ăł@E[eCg
	dey				;
	bne	mmc5_oct_set2		;IN^[uJԂ

mmc5_freq_end:
	jsr	detune_write_sub
	rts
;---------------------------------------------------------------
sound_mmc5_read:
	jsr	reg400x
	
	lda	sound_bank,x
	jsr	change_bank
	
	lda	[sound_add_low,x]
;----------
;[v1
mmc5_loop_program
	cmp	#$a0
	bne	mmc5_loop_program2
	jsr	loop_sub
	jmp	sound_mmc5_read
;----------
;[v2()
mmc5_loop_program2
	cmp	#$a1
	bne	mmc5_bank_command
	jsr	loop_sub2
	jmp	sound_mmc5_read
;----------
;oN؂ւ
mmc5_bank_command
	cmp	#$ee
	bne	mmc5_data_end
	jsr	data_bank_addr
	jmp	sound_mmc5_read
;----------
;f[^Ghݒ
mmc5_data_end:
	cmp	#$ff
	bne	mmc5_wave_set
	jsr	data_end_sub
	jmp	sound_mmc5_read
;----------
;Fݒ
mmc5_wave_set:
	cmp	#$fe
	bne	mmc5_volume_set
	jsr	sound_data_address
	lda	[sound_add_low,x]	;Ff[^ǂݏo
	pha
	and	#%10000000		;8bitڊmF
	cmp	#%10000000
	bne	mmc5_duty_enverope_part	;a[eBGx

mmc5_duty_select_part:
	lda	effect_flag,x
	and	#%11111011
	sta	effect_flag,x		;f[eBGx[vw
	jsr	reg400x
	pla
	asl	a
	asl	a
	asl	a
	asl	a
	asl	a
	asl	a
	ora	#%00110000		;waveform hold on & hardware envelope off
	sta	register_high,x		;
	ora	register_low,x
	sta	MMC5_REG_CTRL-MMC5_START_CH*4,y
	jsr	sound_data_address
	jmp	sound_mmc5_read

mmc5_duty_enverope_part:
	lda	effect_flag,x
	ora	#%00000100
	sta	effect_flag,x		;f[eBGx[vLw
	pla
	sta	duty_sel,x
	asl	a
	tay
	lda	dutyenve_table,y	;f[eBGx[vAhXݒ
	sta	duty_add_low,x
	iny
	lda	dutyenve_table,y
	sta	duty_add_high,x
	jsr	sound_data_address
	jmp	sound_mmc5_read

;----------
;ʐݒ
mmc5_volume_set:
	cmp	#$fd
	bne	mmc5_rest_set
	jsr	sound_data_address
	lda	[sound_add_low,x]
	sta	temporary
	and	#%10000000		;bit7mF
	cmp	#%10000000
	bne	mmc5_softenve_part		;\tgGx

mmc5_volume_part:
	lda	effect_flag,x
	and	#%11111110
	sta	effect_flag,x		;\tgGxw

	lda	temporary
	and	#%00001111
	sta	register_low,x
	ora	register_high,x
	sta	MMC5_REG_CTRL-MMC5_START_CH*4,y			;{[
	jsr	sound_data_address
	jmp	sound_mmc5_read

mmc5_softenve_part:
	jsr	mmc5_volume_sub
	jmp	sound_mmc5_read
mmc5_volume_sub:
	lda	effect_flag,x
	ora	#%00000001
	sta	effect_flag,x		;\tgGxLw

;	lda	#$00
;	sta	register_low,x		;ʏ{[[

	lda	temporary
	sta	softenve_sel,x
	asl	a
	tay
	lda	softenve_table,y	;\tgGxf[^AhXݒ
	sta	soft_add_low,x
	iny
	lda	softenve_table,y
	sta	soft_add_high,x
	jsr	sound_data_address
	rts

;----------
mmc5_rest_set:
	cmp	#$fc
	bne	mmc5_lfo_set

	lda	rest_flag,x
	ora	#%00000001
	sta	rest_flag,x

	jsr	sound_data_address
	lda	[sound_add_low,x]
	sta	sound_counter,x

	lda	register_high,x
	sta	MMC5_REG_CTRL-MMC5_START_CH*4,y
	jsr	sound_data_address
	rts
;----------
mmc5_lfo_set:
	cmp	#$fb
	bne	mmc5_detune_set
	jsr	lfo_set_sub
	jmp	sound_mmc5_read
;----------
mmc5_detune_set:
	cmp	#$fa
	bne	mmc5_pitch_set
	jsr	detune_sub
	jmp	sound_mmc5_read
;----------
;sb`Gx[vݒ
mmc5_pitch_set:
	cmp	#$f8
	bne	mmc5_arpeggio_set
	jsr	pitch_set_sub
	jmp	sound_mmc5_read
;----------
;m[gGx[vݒ
mmc5_arpeggio_set:
	cmp	#$f7
	bne	mmc5_freq_direct_set
	jsr	arpeggio_set_sub
	jmp	sound_mmc5_read
;----------
;Đgڐݒ
mmc5_freq_direct_set:
	cmp	#$f6
	bne	mmc5_y_command_set
	jsr	direct_freq_sub
	rts
;----------
;R}hݒ
mmc5_y_command_set:
	cmp	#$f5
	bne	mmc5_wait_set
	jsr	y_sub
	jmp	sound_mmc5_read
;----------
;EFCgݒ
mmc5_wait_set:
	cmp	#$f4
	bne	mmc5_oto_set
	jsr	wait_sub
	rts
;----------
mmc5_oto_set:
	sta	sound_sel,x		;͂܂
	jsr	sound_data_address
	lda	[sound_add_low,x]	;ǂݏo
	sta	sound_counter,x		;ۂ̃JEglƂȂ܂
	jsr	sound_data_address
	jsr	mmc5_freq_set		;gZbg
	jsr	effect_init
	rts
;-------------------------------------------------------------------------------
sound_mmc5_write:
	jsr	reg400x
	lda	register_low,x		;ʕێ
	ora	register_high,x
	sta	MMC5_REG_CTRL-MMC5_START_CH*4,y
mmc5_write:
	lda	sound_freq_low,x	;Low Write
	sta	MMC5_REG_FREQ_L-MMC5_START_CH*4,y
	lda	sound_freq_high,x	;High Write
	sta	MMC5_REG_FREQ_H-MMC5_START_CH*4,y
	rts
;-----------------------------------------------------
sound_mmc5_softenve:
	jsr	volume_enve_sub
	sta	register_low,x
	ora	register_high,x		;Ff[^i4bitjƉ4bitőZ
	sta	MMC5_REG_CTRL-MMC5_START_CH*4,y			;݁`
	jsr	enverope_address	;AhX₵
	rts				;܂
;-------------------------------------------------------------------------------
sound_mmc5_lfo:
	lda	sound_freq_high,x
	sta	temporary
	jsr	lfo_sub
	lda	sound_freq_low,x
	sta	MMC5_REG_FREQ_L-MMC5_START_CH*4,y
	lda	sound_freq_high,x
	cmp	temporary
	beq	mmc5_end4
	sta	MMC5_REG_FREQ_H-MMC5_START_CH*4,y
mmc5_end4:
	rts
;-------------------------------------------------------------------------------
sound_mmc5_pitch_enve:
	lda	sound_freq_high,x
	sta	temporary
	jsr	pitch_sub
mmc5_pitch_write:
	lda	sound_freq_low,x
	sta	MMC5_REG_FREQ_L-MMC5_START_CH*4,y
	lda	sound_freq_high,x
	cmp	temporary
	beq	mmc5_end3
	sta	MMC5_REG_FREQ_H-MMC5_START_CH*4,y
mmc5_end3:
	jsr	pitch_enverope_address
	rts
;-------------------------------------------------------------------------------
sound_mmc5_note_enve
	lda	sound_freq_high,x
	sta	temporary2
	jsr	note_enve_sub
	jsr	mmc5_freq_set
mmc5_note_freq_write:
	jsr	reg400x
	lda	sound_freq_low,x
	sta	MMC5_REG_FREQ_L-MMC5_START_CH*4,y
	lda	sound_freq_high,x
	cmp	temporary2
	beq	mmc5_end2
	sta	MMC5_REG_FREQ_H-MMC5_START_CH*4,y
mmc5_end2:
	jsr	arpeggio_address
	rts
;-------------------------------------------------------------------------------
sound_mmc5_dutyenve:
	jsr	reg400x

	indirect_lda	duty_add_low		;Gx[vf[^ǂݍ
	cmp	#$ff			;Ōォǁ[
	beq	mmc5_return22		;ŌȂ炻̂܂܂܂
	asl	a
	asl	a
	asl	a
	asl	a
	asl	a
	asl	a
	ora	#%00110000		;waveform hold on & hardware envelope off
	sta	register_high,x
	ora	register_low,x		;Ff[^i4bitjƉ4bitőZ
	sta	MMC5_REG_CTRL-MMC5_START_CH*4,y			;݁`
	jsr	duty_enverope_address	;AhX₵
	rts				;܂

mmc5_return22:
	lda	duty_sel,x
	asl	a
	tay
	lda	dutyenve_lp_table,y
	sta	duty_add_low,x
	iny
	lda	dutyenve_lp_table,y
	sta	duty_add_high,x
	jmp	sound_mmc5_dutyenve
;-------------------------------------------------------------------------------
